import { useEffect } from 'react'

const clamp = (val, min, max) => Math.min(Math.max(val, min), max)

export default ({
    trackProgress, trackDuration, startTime,
    setTrackProgress, trackPlaying,
}) => {
    useEffect(() => {
        let animation
        if (trackPlaying) {
            animation = window.requestAnimationFrame(() => {
                console.log("ani");
                const trackProgressPerc = ((Date.now() / 1000 - startTime)) * 100 / trackDuration
                setTrackProgress(
                    clamp(
                        trackProgressPerc,
                        0, 100,
                    ),
                )
            })
        }
        return () => {
            window.cancelAnimationFrame(animation)
        }
    }, [
        trackPlaying,
        trackDuration,
        startTime,
        trackProgress,
    ])
}